/***
* stub.c -
*
*       Copyright (c) 1989-1992, Microsoft Corporation.  All rights reserved.
*
*******************************************************************************/

#include <version.h>
#include <vmm.h>


PVOID VMFUNC __PVmLoadStubVpCb(VPVOID vp, unsigned long cb, int fDirty) {

PVOID   pvoid;

// just do a single page load if it is within one page
if( IbOfVp(vp) + cb <= (unsigned long) cbVmPage )
    return(__PVmLoadVp(vp, fDirty));

pvoid = __PVmLockVpCb(vp, cb);
if( pvoid != 0L )
    __VmUnlockVpCb(vp, cb, fDirty);

return(pvoid);
}
